#include "Application.h"
#include <iostream>

Application::Application() :
key(true)
{};

void Application::CreateDataMenu()
{
	while (key)
	{
		std::cout << "1 - createData" << '\n'
			<< "2 - createData with generate" << '\n'
			<< "0 - EXIT" << std::endl;
		std::cin >> select;
		switch (select)
		{
		case 1:
			std::cout << "Input fileName" << std::endl;
			std::cin >> fileName;
			createData(fileName);
			break;
		case 2:
			std::cout << "Input fileName" << std::endl;
			std::cin >> fileName;
			_createData(fileName);
			break;
		case 0:
			key = false;
			break;
		default:
			std::cout << "Error" << std::endl;
			break;
		}
	}
	key = true;
}

void Application::LoadDataMenu()
{
	while (key)
	{
		std::cout << "1 - loadData" << '\n'
			<< "2 - loadData with copy" << '\n'
			<< "0 - EXIT" << std::endl;
		std::cin >> select;
		switch (select)
		{
		case 1:
			std::cout << "Input fileName" << std::endl;
			std::cin >> fileName;
			vec = loadData<std::vector<int>>(fileName);
			std::cout << "Resualt:" << std::endl;
			for (const auto& p_a : vec)
				std::cout << p_a << '|';
			std::cout << std::endl;
			vec.clear();
			break;
		case 2:
			std::cout << "Input fileName" << std::endl;
			std::cin >> fileName;
			vec = _loadData<std::vector<int>>(fileName);
			std::cout << "Resualt:" << std::endl;
			for (const auto& p_a : vec)
				std::cout << p_a << '|';
			std::cout << std::endl;
			vec.clear();
			break;
		case 0:
			key = false;
			break;
		default:
			std::cout << "Error" << std::endl;
			break;
		}
	}
	key = true;
}

void Application::ModifayMenu()
{
	while (key)
	{
		std::cout << "1 - modify (return Container)" << '\n'
			<< "2 - modify" << '\n'
			<< "3 - modify with for_each" << '\n'
			<< "4 - modify with transform" << '\n'
			<< "0 - EXIT" << std::endl;
		std::cin >> select;
		if (select != 0) 
		{
			std::cout << "Input fileName" << std::endl;
			std::cin >> fileName;
		}

		std::ifstream file;
		file.open(fileName);
		std::istream_iterator<int> it(file);
		std::istream_iterator<int> it_eof;
		if (select != 2)
			file.close();

		switch (select)
		{
		case 1:
			std::cout << "Resualt of modifay:" << std::endl;
			vec = modify_1<std::vector<int>>(fileName);
			for (const auto& p_a : vec)
				std::cout << p_a << '|';
			std::cout << std::endl;
			break;
		case 2:
			modify_2(it, it_eof);
			file.close();
			remove(fileName.c_str());
			rename("new.txt", fileName.c_str());
			break;
		case 3:
		    modify_3(fileName);
			break;
		case 4:
			modify_4(fileName);
			break;
		case 0:
			key = false;
			break;
		default:
			std::cout << "Error" << std::endl;
			break;
		}
	}
	
	key = true;
}

void Application::OutMenu()
{
	while (key)
	{
		std::cout << "1 - outputResult" << '\n'
			<< "2 - outputResult with copy" << '\n'
			<< "0 - EXIT" << std::endl;
		std::cin >> select;
		if (select != 0)
		{
			std::cout << "Input fileName" << std::endl;
			std::cin >> fileName;
			std::cout << "Input newFileName" << std::endl;
			std::cin >> newFileName;
			if (vec.empty())
				vec = _loadData<std::vector<int>>(fileName);
		}
		switch (select)
		{
		case 1:
			outputResult<std::vector<int>>(newFileName, vec);
			break;
		case 2:
			outputResult<std::vector<int>>(newFileName, vec);
			break;
		case 0:
			key = false;
			break;
		default:
			std::cout << "Error" << std::endl;
			break;
		}
	}
	key = true;
}

void Application::menu()
{
	while (key)
	{
	std::cout << "1 - Create Functions" << '\n'
		<< "2 - LoadData Functions" << '\n'
		<< "3 - Modifay Functions" << '\n'
		<< "4 - outputResult Functions" << '\n'
		<< "0 - EXIT" << std::endl;
	std::cin >> select;
		switch (select)
		{
		case 1:
			CreateDataMenu();
			break;
		case 2:
			LoadDataMenu();
			break;
		case 3:
			ModifayMenu();
			break;
		case 4:
			OutMenu();
			break;
		case 0:
			key = false;
			break;
		default:
			std::cout << "Error" << std::endl;
		}
	}
}

